
Redmine - Feature #5634

Export issue to PDF does not include Subtasks and Related Issues

2010-06-02 11:58 - Daniel N

Status: Closed Start date: 2010-06-02

Priority: Normal Due date:  

Assignee: Toshi MARUYAMA % Done: 100%

Category: Issues Estimated time: 0.00 hour

Target version: 1.3.0   

Resolution: Fixed   

Description

Using Redmine trunk, exporting an issue to PDF misses the new subtaks (#443) and also related task in the PDF export. (

source:trunk/lib/redmine/export).

Related issues:

Related to Redmine - Patch #8617: Indent subject of subtask ticket in exporte... Closed 2011-06-15

Has duplicate Redmine - Feature #9535: Export PDF with subtask Closed 2011-11-07

Associated revisions

Revision 7787 - 2011-11-12 12:17 - Toshi MARUYAMA

pdf: add ancestor issues at head of issue pdf (#5634)

Contributed by Bernhard Furtmueller and Jun NAITOH.

Revision 7788 - 2011-11-12 12:18 - Toshi MARUYAMA

pdf: add subtasks and related issues at issue pdf (#5634)

Contributed by Bernhard Furtmueller and Jun NAITOH.

Revision 7845 - 2011-11-19 14:36 - Jean-Philippe Lang

Omit subtasks/related issues sections when empty on PDF export (#5634).

Revision 7965 - 2011-11-28 06:58 - Toshi MARUYAMA

pdf: expand relational issues status column width of issue pdf (#5634)

History

#1 - 2010-06-19 02:37 - Eric Davis

- Tracker changed from Defect to Feature

#2 - 2010-08-17 11:27 - Daniel N

- Status changed from New to Resolved

- % Done changed from 0 to 90

Thanks to Heiko this solves it for me:

        i = 0

        issue.relations.select { |r| r.other_issue(issue).visible? }.each do |relation|

          if i == 0

            pdf.SetFontStyle('B',9)

            pdf.Cell(35,5, l(relation.label_for(issue)) + ":", "LT")

            pdf.SetFontStyle('', 9)

            pdf.MultiCell(155,5, "#{relation.other_issue(issue).project} - #{relation.other_issue(issue).track

er} # #{relation.other_issue(issue).id}: #{relation.other_issue(issue).subject}", "RT")

          else

            pdf.SetFontStyle('B',9)

            pdf.Cell(35,5, l(relation.label_for(issue)) + ":", "L")

            pdf.SetFontStyle('', 9)

            pdf.MultiCell(155,5, "#{relation.other_issue(issue).project} - #{relation.other_issue(issue).track

er} # #{relation.other_issue(issue).id}: #{relation.other_issue(issue).subject}", "R")
          end

          i += 1

        end

 insert above after the following block:

        for custom_value in issue.custom_field_values

          pdf.SetFontStyle('B',9)

          pdf.Cell(35,5, custom_value.custom_field.name + ":","L")

          pdf.SetFontStyle('',9)

          pdf.MultiCell(155,5, (show_value custom_value),"R")

        end

 in lib/redmine/export/pdf.rb

#3 - 2011-01-28 19:56 - Bernhard Furtmueller

- File pdf.rb_1.0.5.patch added

I took this patch and enhanced it to really show subtasks, also ancestors are shown on top

#4 - 2011-01-28 20:57 - Bernhard Furtmueller

- File 0001-Forward-port-of-Export-issue-to-PDF-does-not-include.patch added

#5 - 2011-02-07 09:39 - Bernhard Furtmueller

- File pdf.png added

#6 - 2011-06-02 12:07 - Xiaobing Sun

Thanks you for the fix.

Open it can be adopted to the trunk.

The code can work on 1.1.2.

For 1.2.0, it need a little change.

#7 - 2011-06-03 09:27 - Etienne Massip

- Status changed from Resolved to New

- Target version set to Candidate for next major release

#8 - 2011-08-26 19:30 - Bernhard Furtmueller

- File 0001-Forward-port-of-Export-issue-to-PDF-does-not-include_2.patch added

#9 - 2011-11-09 00:51 - yannick  quenec'hdu

Hi Bernhard,

Your Patch need a little change to work with Redmine 1.2.1

Thank for your patch

Cheers

Yannick

#10 - 2011-11-11 09:20 - Toshi MARUYAMA

- Status changed from New to 7

- Assignee set to Toshi MARUYAMA

#11 - 2011-11-11 09:57 - Jun NAITOH

Hi, I rewritie note-8 patch for trunk, now.

I think to note-8 patch have some probrem.

If you wait some day, so I will post new patch.

Please wait.

#12 - 2011-11-11 11:00 - Toshi MARUYAMA

- File r7764.patch added
This is a patch for r7764.

#13 - 2011-11-11 11:06 - Toshi MARUYAMA

Note 12 patch line 288-298 has smart indents.

But, line 364-407 indents and truncating is ugly.

Could you rewrite?

#14 - 2011-11-12 00:35 - Jun NAITOH

- File pdf.rb_r7782.patch added

Toshi MARUYAMA wrote:

Note 12 patch line 288-298 has smart indents.

 I rewrite now.

delete ancestor.project. Because ancestor.project is identical with issue's project.

delete issue.subject by title. Because it is duplicate in the Cell.

add limit for nesting.

But, line 364-407 indents and truncating is ugly.

Could you rewrite?

 Sorry, I tried rewrite 364-407 with MultiCell now. But I give up use MultiCell.

If I use MultiCell, so I need MovePage(back to before page) method. But TCPDF didn't have this method.

I think to your implementation isn't best, but better.

I added to limit for nesting.

I attached rewrite patch for r7782.

#15 - 2011-11-12 11:51 - Toshi MARUYAMA

- Subject changed from Export issue to PDF does not include Subtaks and Related Issues to Export issue to PDF does not include Subtasks and

Related Issues

#16 - 2011-11-12 12:24 - Toshi MARUYAMA

- Target version changed from Candidate for next major release to 1.3.0

- % Done changed from 90 to 100

I committed note 14 patch in trunk r7787 and r7788.

I changed one line.

source:trunk/lib/redmine/export/pdf.rb@7788#L365

#17 - 2011-11-13 02:55 - Jun NAITOH

Thank you!

#18 - 2011-11-19 14:37 - Jean-Philippe Lang

- Status changed from 7 to Closed

- Resolution set to Fixed

I think we can close now.

Files

pdf.rb_1.0.5.patch 4.16 KB 2011-01-28 Bernhard Furtmueller

0001-Forward-port-of-Export-issue-to-PDF-does-not-include.patch 4.43 KB 2011-01-28 Bernhard Furtmueller

pdf.png 57.1 KB 2011-02-07 Bernhard Furtmueller

0001-Forward-port-of-Export-issue-to-PDF-does-not-include_2.patch 3.47 KB 2011-08-26 Bernhard Furtmueller

r7764.patch 3.2 KB 2011-11-11 Toshi MARUYAMA

pdf.rb_r7782.patch 3.31 KB 2011-11-11 Jun NAITOH
